---
title: MediaStreamConstraints.video
slug: Web/API/MediaStreamConstraints/video
tags:
  - API
  - Audio
  - Constraints
  - Dictionary
  - Interface
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaStreamConstraints
  - Reference
  - Video
  - getusermedia
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The {{domxref("MediaStreamConstraints")}} dictionary's <strong><code>video</code></strong> property is used to indicate what kind of video track, if any, should be included in the {{domxref("MediaStream")}} returned by a call to {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}.</p>

<p>To learn more about how constraints work, see <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>videoConstraints</em> = true | false | <em>MediaTrackConstraints</em>;
</pre>

<h3 id="Value">Value</h3>

<p>The value of the <code>video</code> property can be specified as either of two types:</p>

<dl>
 <dt>{{jsxref("Boolean")}}</dt>
 <dd>If a Boolean value is specified, it indicates whether or not a video track should be included in the returned stream; if it's <code>true</code>, a video track is included; if no video source is available or if permission is not given to use the video source, the call to <code>getUserMedia()</code> will fail. If <code>false</code>, no video track is included.</dd>
 <dt>{{domxref("MediaTrackConstraints")}}</dt>
 <dd>A constraints dictionary detailing the preferable and/or required values or ranges of values for the track's constrainable properties. If you specify constraints, a video track meeting these constraints is required.</dd>
</dl>

<h2 id="Example">Examples</h2>

<h3 id="Using_a_Boolean_value">Using a Boolean value</h3>

<p>In this example, we provide a simple value of <code>true</code> for the <code>video</code> property. This tells <code>getUserMedia()</code> that we require a video track, but we don't care about any specifics beyond that.</p>

<div class="hidden">
<h4 id="HTML_content">HTML content</h4>

<pre class="brush: html">&lt;p&gt;Click the start button below to begin the demonstration.&lt;/p&gt;
&lt;div id="startButton" class="button"&gt;
  Start
&lt;/div&gt;
&lt;video id="video" width="160" height="120" autoplay&gt;&lt;/video&gt;&lt;br&gt;
&lt;div id="log"&gt;&lt;/div&gt;</pre>

<h4 id="CSS_content">CSS content</h4>

<pre class="brush: css">body {
  font: 14px "Open Sans", "Arial", sans-serif;
}

video {
  margin-top: 20px;
  border: 1px solid black;
}

.button {
  cursor: pointer;
  width: 160px;
  border: 1px solid black;
  font-size: 16px;
  text-align: center;
  padding-top: 2px;
  padding-bottom: 4px;
  color: white;
  background-color: darkgreen;
}</pre>

<h4 id="JavaScript_content">JavaScript content</h4>

<pre class="brush: js">let videoElement = document.getElementById("video");
let logElement = document.getElementById("log");

function log(msg) {
 logElement.innerHTML += msg + "&lt;br&gt;";
}
</pre>
</div>

<pre class="brush: js">document.getElementById("startButton").addEventListener("click", function() {
  navigator.mediaDevices.getUserMedia({
      video: true
  }).then(stream =&gt; videoElement.srcObject = stream)
    .catch(err =&gt; log(err.name + ": " + err.message));
}, false);</pre>

<p>Here we see an event handler for a {{domxref("click")}} event which uses {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} to obtain a video-only stream with no specific constraints, then attaches the resulting stream to a {{HTMLElement("video")}} element once the stream is returned.</p>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Using_a_Boolean_value', 600, 280, "", "", "", "camera") }}</p>

<h3 id="Using_a_MediaTrackConstraints_object">Using a MediaTrackConstraints object</h3>

<p>Now let's look at a similar example that uses a set of constraints based on the {{domxref("MediaTrackConstraints")}} dictionary:</p>

<div class="hidden">
<h4 id="HTML_content_2">HTML content</h4>

<pre class="brush: html">&lt;p&gt;Click the start button below to begin the demonstration.&lt;/p&gt;
&lt;div id="startButton" class="button"&gt;
  Start
&lt;/div&gt;
&lt;video id="video" width="160" height="120" autoplay&gt;&lt;/video&gt;&lt;br&gt;
&lt;div id="log"&gt;&lt;/div&gt;</pre>

<h4 id="CSS_content_2">CSS content</h4>

<pre class="brush: css">body {
  font: 14px "Open Sans", "Arial", sans-serif;
}

video {
  margin-top: 20px;
  border: 1px solid black;
}

.button {
  cursor: pointer;
  width: 160px;
  border: 1px solid black;
  font-size: 16px;
  text-align: center;
  padding-top: 2px;
  padding-bottom: 4px;
  color: white;
  background-color: darkgreen;
}</pre>

<h4 id="JavaScript_content_2">JavaScript content</h4>

<pre class="brush: js">let videoElement = document.getElementById("video");
let logElement = document.getElementById("log");

function log(msg) {
 logElement.innerHTML += msg + "&lt;br&gt;";
}
</pre>
</div>

<pre class="brush: js">document.getElementById("startButton").addEventListener("click", function() {
  navigator.mediaDevices.getUserMedia({
      video: {
        width: 160,
        height: 120,
        frameRate: 15
      }
  }).then(stream =&gt; videoElement.srcObject = stream)
    .catch(err =&gt; log(err.name + ": " + err.message));
}, false);</pre>

<p>Here we see an event handler for a {{domxref("click")}} event which calls {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}, specifying a set of video constraints that indicate a preference for a video track whose dimensions are as close as possible to 160x120 pixels, and whose frame rate is as close to 15 frames per second as possible. As long as a video input device is available and the user allows it to be used, a video track will be included in the resulting stream, and it will match the specified constraints as well as possible.</p>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Using_a_MediaTrackConstraints_object', 600, 280, "", "", "", "camera") }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Media Capture', '#dom-mediastreamconstraints-video', 'MediaStreamConstraints.video') }}</td>
   <td>{{ Spec2('Media Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamConstraints.video")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("MediaDevices.getUserMedia()")}}</li>
 <li>{{domxref("MediaDevices.getSupportedConstraints()")}}</li>
 <li>{{domxref("MediaTrackSupportedConstraints")}}</li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
</ul>
